<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!-- saved from url=(0047)http://www.unrealscript.com/tutorials/tut18.php -->
<HTML>
<!-- Mirrored from korelabs.us/koregaming/downloads/Unreal Tournament/Guides/chimeric.beyondunreal.com/data/PenetratingWeapons.htm by HTTrack Website Copier/3.x [XR&CO'2014], Thu, 08 Jan 2015 09:44:13 GMT -->
<HEAD><TITLE>CHiMERiC - The Unrealscript Coding Resource</TITLE>
<META http-equiv=Content-Type content="text/html; charset=windows-1250">
<META content="MSHTML 5.50.4134.600" name=GENERATOR></HEAD>
<BODY text=white vLink=white link=white bgColor=black><!-- ===== Begin Header ===== -->
<DIV align=center>
<CENTER><A target=_blank 
href="http://phpads.beyondunreal.com/adclick.php?bannerid=36&amp;zoneid=0&amp;source=&amp;dest=http%3A%2F%2Fwww.qksrv.net%2Fclick-1127352-3083378&amp;ismap="><IMG 
height=60 alt="Ulead GIF Animator" src="Pe/3083378-13.5c.delaye" 
width=468 border=0></A><IMG style="WIDTH: 0px; HEIGHT: 0px" height=0 alt="" 
src="#" width=0> 
<TABLE width=480 border=0>
  <TBODY>
  <TR>
    <TD align=middle><IMG height=108 
      src="Pene/chimeric.5d.delaye" width=379> 
</TD></TR></TBODY></TABLE></CENTER></DIV><!-- ===== End Header ===== --><BR><!-- ===== Begin Menu Bar ===== -->
<DIV align=center>
<CENTER>
<TABLE cellSpacing=0 width=430 borderColorLight=#c0c0c0 border=1>
  <TBODY>
  <TR>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="http://www.unrealscript.com/"><B><FONT face="MS Sans Serif" 
      size=1>news</FONT></B> </A></TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="http://www.unrealscript.com/about.php"><B><FONT face="MS Sans Serif" 
      size=1>about</FONT></B> </A></TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="http://forums.beyondunreal.com/forumdisplay.php?forumid=101"><B><FONT 
      face="MS Sans Serif" size=1>forums</FONT></B> </A></TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="http://www.unrealscript.com/links.php"><B><FONT face="MS Sans Serif" 
      size=1>links</FONT></B> </A></TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><B><FONT 
      face="MS Sans Serif" size=1>mods</FONT></B> </TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="http://www.unrealscript.com/tools.php"><B><FONT face="MS Sans Serif" 
      size=1>tools</FONT></B> </A></TD>
    <TD vAlign=top align=middle width=53 bgColor=#666666><B><FONT 
      face="MS Sans Serif" size=1>tutorials</FONT></B> </TD>
    <TD vAlign=top align=middle width=53 bgColor=#808080><A 
      href="mailto:ray@beyondunreal.com"><B><FONT face="MS Sans Serif" 
      size=1>contact</FONT></B> </A></TD></TR></TBODY></TABLE></CENTER></DIV><!-- ===== End Menu Bar ===== -->
<DIV align=center>
<TABLE cellSpacing=0 cellPadding=4 width=430 borderColorLight=#c0c0c0 border=1><!-- ===== Begin Tutorial Title ===== -->
  <TBODY>
  <TR>
    <TD vAlign=center align=left width="80%" bgColor=#808080><FONT 
      face="MS Sans Serif" color=#ffffff size=1><B>Penetrating Weapons - 
      author:&nbsp;[</B><A 
      href="mailto:mrsd@unrealscript.com">mr.self-destruct</A><B>]</B></FONT> 
  </TD></TR><!-- ===== End Tutorial Title ===== --><!-- ===== Begin Tutorial Content ===== -->
  <TR>
    <TD vAlign=top align=left width=430 
    background=/bg_blueblack.5e.delaye bgColor=#000033>
      <P align=left><FONT face="Verdana, Arial, Helvetica" size=-1>
      <H4>Theory</H4>In Unreal Tournament weapons that immediately hit their 
      target use a trace to locate the target. The trace begins at the player 
      who fired the weapon, travels along their line of sight until it 
      intersects an object (be it wall or player). If we simplify the problem by 
      treating it in 2D, the diagram below illustrates what happens when a 
      normal weapon shoot at a wall:
      <P>
      <DIV align=center><IMG title="Normal weapon" 
      src="Penetrati/pw1.5f.delaye" align=center></DIV>
      <P>You'll have to excuse the dodgy diagrams in this tutorial, my drawing 
      skills are somewhat lacking :P
      <P>Now to make a weapon appear to fire through a wall we need to begin a 
      second trace starting at a distance <I>x</I> from the where the first 
      trace ended. x is the penetration factor, how thick a wall the weapon will 
      appear to shoot through. When the wall is thinner than <I>x</I> the 2nd 
      trace will continue along until it intersects another object:
      <P>
      <DIV align=center><IMG title="wall < x" 
      src="Penetrati/pw2.60.delaye" align=center></DIV>
      <P>When the wall is thicker than x the 2nd trace will hit the inside of 
      the wall and stop:
      <P>
      <DIV align=center><IMG title=" wall > x" 
      src="PenetratingWeapons_pliki/pw3.gif" align=center></DIV>
      <P>In the real world it's slightly more complicated that than. A player is 
      soft, so a powerful gun will shoot through them easily, a wall is hard and 
      so the weapon will penetrate through it less. The problem lies in the fact 
      that player's are quite thick, so the penetration factor must be quite 
      high to go through them, with the result that it'll go through thicker 
      walls than we want it to. The solution to the problem is to have two 
      penetration factors, one for pawns and one for anything else. We then 
      check what the first trace hit and then use the relevant penetration 
      factor.
      <P>
      <H4>Code</H4>"Great you've explained it all and yes the method is quite 
      simple, but how to implement it?" I hear you say. Easy! All you need to do 
      is override the TraceFire() function to implement the second trace. Before 
      I give you the code, remember that it doesn't cut and paste into a new 
      weapon too well. In part this is because it calls ProcessTraceHit() twice, 
      and this is where things such as shell cases get spawned.
      <P><!-- ===== Begin Code Snippet ===== -->
      <TABLE borderColor=#c0c0c0 width="100%" bgColor=#333333 
      borderColorLight=#c0c0c0 border=1>
        <TBODY>
        <TR>
          <TD borderColor=#333333 borderColorLight=#333333 width="100%" 
          background=/bg_graycross.61.delaye 
          borderColorDark=#333333><FONT face="MS Sans Serif" color=#ffff00 
            size=1><B>// Weapon fire that goes through wall
            <P>// Penetration through walls<BR>var() float Thick;<BR>// 
            Penetration through pawns<BR>var() float PawnThick;<BR>function 
            TraceFire( float Accuracy )<BR>{<BR>&nbsp;&nbsp;local vector 
            HitLocation, HitNormal, StartTrace, EndTrace, 
            X,Y,Z;<BR>&nbsp;&nbsp;local actor Other;<BR>&nbsp;&nbsp;local Pawn 
            PawnOwner;<BR>&nbsp;&nbsp;local float Penetration;
            <P>&nbsp;&nbsp;PawnOwner = Pawn(Owner);
            <P>&nbsp;&nbsp;Owner.MakeNoise(PawnOwner.SoundDampening);<BR>&nbsp;&nbsp;GetAxes(PawnOwner.ViewRotation,X,Y,Z);<BR>&nbsp;&nbsp;// 
            First trace, just like ordinary weapon<BR>&nbsp;&nbsp;StartTrace = 
            Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y 
            * Y + FireOffset.Z * Z;<BR>&nbsp;&nbsp;AdjustedAim = 
            PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, 
            False);<BR>&nbsp;&nbsp;EndTrace = StartTrace + Accuracy * (FRand() - 
            0.5 )* Y * 1000 + Accuracy * (FRand() - 0.5 ) * Z * 
            1000;<BR>&nbsp;&nbsp;X = 
            vector(AdjustedAim);<BR>&nbsp;&nbsp;EndTrace += (10000 * 
            X);<BR>&nbsp;&nbsp;Other = PawnOwner.TraceShot(HitLocation, 
            HitNormal, EndTrace, StartTrace);<BR>&nbsp;&nbsp;// Deal with first 
            target<BR>&nbsp;&nbsp;ProcessTraceHit(Other, HitLocation, HitNormal, 
            X,Y,Z);
            <P>&nbsp;&nbsp;// Second trace, start location takes into account 
            previous target<BR>&nbsp;&nbsp;if 
            (Other.IsA('Pawn'))<BR>&nbsp;&nbsp;&nbsp;&nbsp;Penetration = 
            PawnThick;<BR>&nbsp;&nbsp;else<BR>&nbsp;&nbsp;Penetration = 
            Thick;<BR>&nbsp;&nbsp;StartTrace = HitLocation + HitNormal + 
            (Penetration * X);<BR>&nbsp;&nbsp;EndTrace = StartTrace + Accuracy * 
            (FRand() - 0.5 )* Y * 1000 + Accuracy * (FRand() - 0.5 ) * Z * 
            1000;<BR>&nbsp;&nbsp;EndTrace += (10000 * X);<BR>&nbsp;&nbsp;Other = 
            PawnOwner.TraceShot(HitLocation, HitNormal, EndTrace, 
            StartTrace);<BR>&nbsp;&nbsp;// Deal with second 
            target<BR>&nbsp;&nbsp;ProcessTraceHit(Other, HitLocation, HitNormal, 
            X,Y,Z);<BR>}
            <P>defaultproperties<BR>{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// Walls 
            are hard, so gun penetrates 
            less<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Thick=20.0<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// 
            Pawns on the other hand are soft and tend to be thicker 
            than<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// walls you want to 
            penetrate<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// 17 is UT's default 
            player collision radius, so make the 
            gun<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// just penetrate a 
            pawn<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;PawnThick=36.0<BR>}<BR></B></FONT></P></TD></TR></TBODY></TABLE><!-- ===== End Code Snippet ===== --><BR>What?! 
      Only nine extra lines strapped on the end of the standard TraceFire() 
      function, I said it was easy to implement ;) 
      <P>
      <H4>Taking it Further</H4>Having outlined the basic principles behind 
      this, it's possible to take it further and devise a technique that will 
      cope with shooting through multiple targets.<BR>The principle behind this 
      is much the same, but it requires several loops and a counter to keep 
      track of how many times we've traced ahead. I'm not going to go into an 
      in-depth discussion of how the technique works, instead I'll just present 
      you with the code (which is quite well commented):
      <P><!-- ===== Begin Code Snippet ===== -->
      <TABLE borderColor=#c0c0c0 width="100%" bgColor=#333333 
      borderColorLight=#c0c0c0 border=1>
        <TBODY>
        <TR>
          <TD borderColor=#333333 borderColorLight=#333333 width="100%" 
          background=/bg_graycross.61.delaye 
          borderColorDark=#333333><FONT face="MS Sans Serif" color=#ffff00 
            size=1><B>// Maximum number of times to trace ahead<BR>var int 
            MaxPenetration;<BR>// How far to trace ahead<BR>var float 
            PenetrationDepth;<BR>// First shot?<BR>var bool bFirst;
            <P>// What did we just hit?<BR>function int ReportMaterial(actor 
            Other)<BR>{<BR>&nbsp;&nbsp;if (Other != 
            None)<BR>&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;if (Other == 
            Level)<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return 1; // 
            Level<BR>&nbsp;&nbsp;&nbsp;&nbsp;else if 
            (Other.bIsPawn)<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return 2; // 
            Pawn<BR>&nbsp;&nbsp;&nbsp;&nbsp;else if 
            (Other.IsA('Decoration'))<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return 
            3; // 
            Decoration<BR>&nbsp;&nbsp;}<BR>&nbsp;&nbsp;else<BR>&nbsp;&nbsp;&nbsp;&nbsp;return 
            4; // Air<BR>}
            <P>// Multiple penetration TraceFire()<BR>function TraceFire (float 
            Accuracy)<BR>{<BR>&nbsp;&nbsp;local vector HitLocation, HitNormal, 
            StartTrace, EndTrace, X,Y,Z, EntryLocation;<BR>&nbsp;&nbsp;local 
            actor Other, LastHit, BOther;<BR>&nbsp;&nbsp;local pawn 
            PawnOwner;<BR>&nbsp;&nbsp;local int 
            Penetration;<BR>&nbsp;&nbsp;local bool bAfterFull;
            <P>&nbsp;&nbsp;// Prepare variables<BR>&nbsp;&nbsp;PawnOwner = 
            Pawn(Owner);<BR>&nbsp;&nbsp;Penetration = 
            MaxPenetration;<BR>&nbsp;&nbsp;Owner.MakeNoise(PawnOwner.SoundDampening);<BR>&nbsp;&nbsp;GetAxes(PawnOwner.ViewRotation,X,Y,Z);<BR>&nbsp;&nbsp;StartTrace 
            = Owner.Location + CalcDrawOffset() + FireOffset.X * X + 
            FireOffset.Y * Y + FireOffset.Z * Z;<BR>&nbsp;&nbsp;AdjustedAim = 
            PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, 
            False);<BR>&nbsp;&nbsp;EndTrace = StartTrace + Accuracy * (FRand() - 
            0.5 )* Y * 1000 + Accuracy * (FRand() - 0.5 ) * Z * 
            1000;<BR>&nbsp;&nbsp;X = 
            vector(AdjustedAim);<BR>&nbsp;&nbsp;EndTrace += (10000 * 
            X);<BR>&nbsp;&nbsp;bFirst = True;<BR>&nbsp;&nbsp;while (Penetration 
            &gt; 0)<BR>&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;// Initial 
            trace<BR>&nbsp;&nbsp;&nbsp;&nbsp;if 
            (bFirst)<BR>&nbsp;&nbsp;&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Other 
            = PawnOwner.TraceShot(HitLocation, HitNormal, EndTrace, 
            StartTrace);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bFirst = 
            False;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bAfterFull = 
            True;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Penetration--;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;EntryLocation 
            = HitLocation + 
            HitNormal;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ProcessTraceHit(Other, 
            HitLocation, HitNormal, 
            X,Y,Z);<BR>&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;// 
            Full length 
            trace<BR>&nbsp;&nbsp;&nbsp;&nbsp;else<BR>&nbsp;&nbsp;&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;StartTrace 
            = EndTrace;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// NB: For more 
            realism, randomly adjust the aim after shooting through 
            something<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;EndTrace += (10000 
            * X);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Other = 
            PawnOwner.TraceShot(HitLocation, HitNormal, EndTrace, 
            StartTrace);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Penetration--;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bAfterFull 
            = True;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;EntryLocation = 
            HitLocation + HitNormal;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if 
            ((LastHit == Level &amp;&amp; bAfterFull) || Other != 
            LastHit)<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ProcessTraceHit(Other, 
            HitLocation, HitNormal, 
            X,Y,Z);<BR>&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;// 
            Trace ahead through whatever we've 
            hit<BR>&nbsp;&nbsp;&nbsp;&nbsp;while (Penetration &gt; 0 &amp;&amp; 
            Other != 
            None)<BR>&nbsp;&nbsp;&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;LastHit 
            = Other;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;// After a full 
            length trace we trace from where we 
            hit<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if 
            (bAfterFull)<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;StartTrace 
            = HitLocation + 
            HitNormal;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;else<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;StartTrace 
            = EndTrace;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;EndTrace = 
            StartTrace + (PenetrationDepth * 
            X);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Other = 
            PawnOwner.TraceShot(HitLocation, HitNormal, EndTrace, 
            StartTrace);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Penetration--;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if 
            (LastHit != 
            Other)<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;bAfterFull 
            = False;<BR>&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;// 
            Back trace for exit decal<BR>&nbsp;&nbsp;&nbsp;&nbsp;BOther = 
            PawnOwner.TraceShot(HitLocation, HitNormal, EntryLocation, 
            EndTrace);<BR>&nbsp;&nbsp;&nbsp;&nbsp;if (BOther == 
            Level)<BR>&nbsp;&nbsp;&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Spawn(class'UT_WallHit',,, 
            HitLocation + HitNormal, 
            Rotator(HitNormal));<BR>&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;else 
            if ((BOther != self) &amp;&amp; (BOther != Owner) &amp;&amp; (BOther 
            != 
            None))<BR>&nbsp;&nbsp;&nbsp;&nbsp;{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if 
            (!BOther.bIsPawn &amp;&amp; 
            !BOther.IsA('Carcass'))<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;spawn(class'UT_SpriteSmokePuff',,, 
            HitLocation + HitNormal * 
            9);<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;else<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;BOther.PlaySound(Sound'ChunkHit',, 
            4.0,, 
            100);<BR>&nbsp;&nbsp;&nbsp;&nbsp;}<BR>&nbsp;&nbsp;&nbsp;&nbsp;// NB: 
            VSize((HitLocation + HitNormal) - EntryLocation) = thickness of what 
            we just<BR>shot through &nbsp;&nbsp;}<BR>}
            <P>defaultproperties<BR>{<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;MaxPenetration=4<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;PenetrationDepth=10.0<BR>}<BR></B></FONT></P></TD></TR></TBODY></TABLE><!-- ===== End Code Snippet ===== --><BR>The 
      above code even generates entry &amp; exit decals :)
      <P>Do note however that a trace is a quite expensive operation to perform 
      and too many going on at once can slow things down. The combination of a 
      small PenetrationDepth &amp; high MaxPenetration and/or using this 
      technique with a weapon with a very high rate of fire could produce a 
      notable drop in performance (but most likely only in the case of a 
      multi-player game with many players using that weapon at once). 
    </FONT></P></TD></TR><!-- ===== End Tutorial Content ===== --><!-- ===== Begin Contact Info ===== -->
  <TR>
    <TD vAlign=center align=left width=430 background="#" bgColor=#000033>
      <P align=center><FONT face="MS Sans Serif" size=1>suggestions? questions? 
      comments? please send them all to <A 
      href="mailto:ray@beyondunreal.com">ray@beyondunreal.com</A></FONT></P></TD></TR><!-- ===== End Contact Info ===== --></TBODY></TABLE></DIV>
<P>
<CENTER></CENTER><BR><!-- ===== Begin Copyright ===== -->
<P></P>
<DIV align=center>
<TABLE width=430 border=0>
  <TBODY>
  <TR>
    <TD align=middle width="100%"><FONT face="Microsoft Sans Serif" 
      color=#808080 size=1>copyright 2001 ray davis.&nbsp; this site and all 
      content belongs to me unless otherwise noted, with the exception of some 
      tutorials.&nbsp; the authors retain the rights to their material, and are 
      hosted here with their express permission.&nbsp; everything else is mine 
      though, so don't steal it. bastards.<BR><A 
      href="http://www.unrealscript.com/privacy.php">privacy</A></FONT></TD></TR></TBODY></TABLE></DIV>
<P align=center><!-- ===== End Copyright ===== --><!-- Begin Nedstat Basic code --><!-- Title: CHiMERiC --><!-- URL: http://www.planetunreal.com/chimeric/ -->
<SCRIPT language=JavaScript src="Penetra/basic.62.delaye">
	</SCRIPT>

<SCRIPT language=JavaScript>
	<!--
	  nedstatbasic("AAV0FAktWGcNl/G3wyTYacDj2H2g", 0);
	// -->
	</SCRIPT>
<NOSCRIPT><A target=_blank 
href="http://v1.nedstatbasic.net/stats?AAV0FAktWGcNl/G3wyTYacDj2H2g"><IMG 
height=18 src="Penetrating/n.63.delaye" width=18 border=0 nosave></A> 
</NOSCRIPT><!-- End Nedstat Basic code --></P></BODY>
<!-- Mirrored from korelabs.us/koregaming/downloads/Unreal Tournament/Guides/chimeric.beyondunreal.com/data/PenetratingWeapons.htm by HTTrack Website Copier/3.x [XR&CO'2014], Thu, 08 Jan 2015 09:44:13 GMT -->
</HTML>
